#!/usr/bin/env node
const url = require("url");
const fs = require("fs-extra");
const path = require("path");
const chalk = require("chalk");
const scrapper = require("./lib/scrapper");
const postmaster = require("./lib/postmaster");

let API;

if (process.argv.length > 2 && typeof process.argv[2] === "string") {
  try {
    API = new url.URL(process.argv[2] + "/wp-json/wp/v2/");
  } catch (e) {
    console.log(`Excepted a URL: ${e}`);
    process.exit(1);
  }
  if (API && process.argv.includes("fetch")) {
    const dest = path.join(process.cwd(), "_data");
    if (fs.existsSync(dest) && fs.lstatSync(dest).isDirectory()) {
      console.log(
        chalk`{cyan _data} directory already exists.\n Please remove it`
      );
    } else {
      scrapper(API);
    }
  } else if (API && process.argv.includes("convert")) {
    postmaster();
  }
} else {
  console.log(chalk`
Usage:

$ pressdown {cyan <url> fetch} to fetch data from worpress
$ pressdown {cyan convert}     to convert fetched data

The {yellow url} must be a wordpress site
`);
  process.exit(1);
}
