const path = require("path");
const fs = require("fs-extra");
const fetch = require("node-fetch");
const ora = require("ora");

/**
 * Download media related to a post
 * @param {object} post
 */
module.exports = async post => {
  const source = path.join(process.cwd(), "_data");
  const dest = path.join(process.cwd(), "content", "blog", post.slug);
  const progress = ora(`Downloading images for ${post.id}`);
  const res = await fs.readJSON(path.join(source, `media-${post.id}.json`));
  try {
    Object.keys(res).forEach(async i => {
      const imageURL = res[i].source_url;
      const imageFile = imageURL.substring(imageURL.lastIndexOf("/") + 1);
      progress.text(`Downloading ${imageURL}...`);
      const result = await fetch(imageURL);
      const file = fs.createWriteStream(path.join(dest, imageFile));
      await result.body.pipe(file);
      progress.text(`Finished Downloading ${imageURL}`);
    });
    progress.succeed(`Finished downloading images for post : ${post.id}`);
  } catch (err) {
    console.log(`Error downloading image... ${err.stack}`);
  }
};
